<?php

class Plugin_Pay_payanyway_p0c6f7e extends Plugin
{
    const ID  = 131;
    const KEY = 'payanyway';

    public function init()
    {
        parent::init();

        $this->setSettings(array(
            'plugin_title'   => 'Плагин оплаты «PayAnyWay»',
            'plugin_version' => '1.0.5',
            'extension_id'   => 'p0c6f7e828a4b2b339fac453a82a780d912841f3',
        ));

        /**
         * Настройки заполняемые в админ. панели
         */
        $this->configSettings(array(
            'id' => array(
                'title' => 'Номер счёта в moneta.ru',
                'input' => 'text',
            ),
            'secret' => array(
                'title' => 'Код проверки целостности данных',
                'input' => 'password',
            ),
            'mode' => array(
                'title' => 'Режим',
                'input' => 'select',
                'type'  => TYPE_STR,
                'default' => 'live',
                'options' => array(
                    'live' => array('title' => 'рабочий'),
                    'test' => array('title' => 'тестовый'),
                ),
            ),
            'currency' => array(
                'title' => 'Валюта',
                'input' => 'select',
                'type'  => TYPE_STR,
                'default' => 'RUB',
                'options' => array(
                    'RUB' => array('title' => 'рубли'),
                ),
            ),
            'fz54' => array(
                'title' => 'Передавать параметры для чека (54-Ф3)',
                'input' => 'select',
                'default' => false,
                'type'  => TYPE_BOOL,
                'options' => array(
                    true => array(
                        'title' => 'передавать',
                    ),
                    false => array(
                        'title' => 'не передавать',
                    ),
                ),
            ),
            'fz54vatType' => array(
                'title' => 'Ставка НДС',
                'input' => 'select',
                'default' => 1105,
                'type'  => TYPE_UINT,
                'description'  => 'Требуется для параметров для чека',
                'options' => array(
                    '1104' => array('title' => 'НДС 0%'),
                    '1103' => array('title' => 'НДС 10%'),
                    '1102' => array('title' => 'НДС 18% (c 01.01.2019 ставка 20%)'),
                    '1105' => array('title' => 'НДС не облагается'),
                    '1107' => array('title' => 'НДС с рассч. ставкой 10%'),
                    '1106' => array('title' => 'НДС с рассч. ставкой 18% (c 01.01.2019 - 20%)'),
                ),
                'visibleIf' => ['fz54' => true],
            ),
            'fz54po' => array(
                'title' => 'Предмет расчета',
                'input' => 'select',
                'default' => 'service',
                'type'  => TYPE_TEXT,
                'description'  => 'Признак предмета расчета',
                'options' => array(
                    'commodity' => array('title' => 'Товар'),
                    'excise' => array('title' => 'Подакцизный товар'),
                    'job' => array('title' => 'Работа'),
                    'service' => array('title' => 'Услуга'),
                    'gambling_bet' => array('title' => 'Ставка в азартной игре'),
                    'gambling_prize' => array('title' => 'Выигрыш в азартной игре'),
                    'lottery' => array('title' => 'Лотерейный билет'),
                    'lottery_prize' => array('title' => 'Выигрыш в лотерею'),
                    'intellectual_activity' => array('title' => 'Результаты интеллектуальной деятельности'),
                    'payment' => array('title' => 'Платеж'),
                    'agent_commission' => array('title' => 'Агентское вознаграждение'),
                    'property_right' => array('title' => 'Имущественные права'),
                    'non_operating_gain' => array('title' => 'Внереализационный доход'),
                    'insurance_premium' => array('title' => 'Страховой сбор'),
                    'sales_tax' => array('title' => 'Торговый сбор'),
                    'resort_fee' => array('title' => 'Курортный сбор'),
                    'composite' => array('title' => 'Несколько вариантов'),
                    'another' => array('title' => 'Другое'),
                ),
                'visibleIf' => ['fz54' => true],
            ),
            'fz54pm' => array(
                'title' => 'Способ расчёта',
                'input' => 'select',
                'default' => 'full_payment',
                'type'  => TYPE_TEXT,
                'description'  => 'Признак способа расчёта',
                'options' => array(
                    'full_prepayment' => array('title' => 'предоплата 100%'),
                    'prepayment' => array('title' => 'предоплата'),
                    'advance' => array('title' => 'аванс'),
                    'full_payment' => array('title' => 'полный расчет'),
                    'partial_payment' => array('title' => 'частичный расчет и кредит'),
                    'credit' => array('title' => 'передача в кредит'),
                    'credit_payment' => array('title' => 'оплата кредита'),
                ),
                'visibleIf' => ['fz54' => true],
            ),
            'process_url' => array(
                'title' => 'Страница обработки оплаты',
                'input' => 'text',
                'readonly' => true,
                'default' => Bills::url('process', array('ps'=>static::KEY)),
            ),
            'success_url' => array(
                'title' => 'Страница успешной оплаты',
                'input' => 'text',
                'readonly' => true,
                'default' => Bills::url('success'),
            ),
            'fail_url' => array(
                'title' => 'Страница ошибки оплаты',
                'input' => 'text',
                'readonly' => true,
                'default' => Bills::url('fail'),
            ),
        ));
    }

    /**
     * Запуск плагина
     */
    protected function start()
    {
        bff::hooks()->billsPaySystemsUser(array($this, 'user_list'));
        bff::hooks()->billsPaySystemsData(array($this, 'system_list'));
        bff::hooks()->billsPayForm(array($this, 'form'));
        bff::hooks()->billsPayProcess(array($this, 'process'));
    }

    /**
     * Дополняем список доступных пользователю способов оплаты
     * @param array $list список систем оплат
     * @param array $extra: 'logoUrl', 'balanceUse'
     * @return array
     */
    public function user_list($list, $extra)
    {
        $list['payanyway_1'] = array(
            'id'           => static::ID,
            'logo_desktop' => $this->url('/payanyway.png'),
            'logo_phone'   => $this->url('/payanyway.png'),
            'way'          => '',
            'title'        => $this->lang('PayAnyWay'), # Название способа оплаты
            'currency_id'  => 2, # Рубли (ID валюты в системе)
            'enabled'      => true, # Способ доступен пользователю
            'priority'     => 0, # Порядок: 0 - последняя, 1+
        );
        return $list;
    }

    /**
     * Дополняем данными о системе оплаты
     * @param array $list
     * @return array
     */
    public function system_list($list)
    {
        $list[static::ID] = array(
            'id'    => static::ID,
            'key'   => static::KEY,
            'title' => 'PayAnyWay', # Название системы для описания счета в админ. панели
            'desc'  => '',
        );
        return $list;
    }

    /**
     * Форма выставленного счета, отправляемая системе оплаты
     * @param string $form HTML форма
     * @param integer $paySystem ID системы оплаты для которой необходимо сформировать форму
     * @param array $data дополнительные данные о выставляемом счете:
     *  amount - сумма для оплаты
     *  bill_id - ID счета
     *  bill_description - описание счета
     * @return string HTML
     */
    public function form($form, $paySystem, $data)
    {
        if ($paySystem != static::ID) return $form;

        $testMode = ($this->config('mode') == 'test');

        $MNT_ID = $this->config('id');
        $MNT_TRANSACTION_ID = $data['bill_id'];
        $MNT_AMOUNT = number_format($data['amount'], 2, '.', '');
        $MNT_CURRENCY_CODE = $this->config('currency');
        $MNT_TEST_MODE = ($testMode ? '1' : '0');
        $secret = $this->config('secret');
        $MNT_SIGNATURE = md5($MNT_ID . $MNT_TRANSACTION_ID . $MNT_AMOUNT . $MNT_CURRENCY_CODE . $MNT_TEST_MODE . $secret);

        $url = 'https://www.payanyway.ru/assistant.htm';
        if ($testMode) {
            $url = 'https://demo.moneta.ru/assistant.htm';
        }

        $custom = '';
        if ($this->config('fz54', false) && !empty($data['bill_data'])) {
            $userID = User::id();
            if ( ! $userID) {
                $userID = 1;
            }
            $userData = Users::model()->userData($userID, array('email'));
            if (empty($userData['email'])) {
                $this->errors->set('Incorrect user E-mail');
                \bff::log('PayAnyWay: 54-FZ Incorrect user E-mail userId=' . $userID, Logger::ERROR, 'bills.log');
                return $form;
            }

            $cleanProductName = function($value) {
                $result = preg_replace('/[^0-9a-zA-Zа-яА-Я-,. ]/ui', '', htmlspecialchars_decode($value));
                return trim(mb_substr($result, 0, 12));
            };

            $name = $cleanProductName($this->getServiceName($data['svc_id'], isset($data['svc_data']) ? $data['svc_data'] : []));

            $item = array(
                'n' => $name,
                'p' => $data['amount'],
                'q' => '1',
                't' => $this->config('fz54vatType', '1105'),
            );

            $info = array(
                'customer' => $userData['email'],
                'items' => [$item],
            );

            $jsonData = preg_replace_callback('/\\\\u(\w{4})/', function ($matches) {
                return html_entity_decode('&#x' . $matches[1] . ';', ENT_COMPAT, 'UTF-8');
            }, json_encode($info));

            $custom = '<input type="hidden" name="MNT_CUSTOM1" value="1" />
            <input type="hidden" name="MNT_CUSTOM2" value="' . $jsonData . '" />';
        }

        $html = '<form action="'.$url.'" method="POST">
                <input type="hidden" name="MNT_ID" value="' . $MNT_ID . '" />
                <input type="hidden" name="MNT_TRANSACTION_ID" value="' . $MNT_TRANSACTION_ID . '" />
                <input type="hidden" name="MNT_AMOUNT" value="' . $MNT_AMOUNT . '" />
                ' . $custom . '
                <input type="hidden" name="MNT_CURRENCY_CODE" value="' . $MNT_CURRENCY_CODE . '" />
                <input type="hidden" name="MNT_TEST_MODE" value="' . $MNT_TEST_MODE . '" />
                <input type="hidden" name="MNT_SIGNATURE" value="' . $MNT_SIGNATURE . '" />
                <input type="hidden" name="MNT_SUCCESS_URL" value="' . $this->config('success_url') . '" />
                <input type="hidden" name="MNT_FAIL_URL" value="' . $this->config('fail_url') . '" />
            </form>';

        return $html;
    }

    protected function getServiceName($svcId, $svcData)
    {
        if ($svcId > 0 && !empty($svcData)) {
            if ($svcData['type'] == Svc::TYPE_SERVICEPACK) {
                $name = $this->lang('Пакет услуг "[title]"', array('title'=>$svcData['title']));
            } else {
                $name = $this->lang('Услуга "[title]"', array('title'=>$svcData['title']));
            }
        } else {
            $name = $this->lang('Пополнение счета');
        }
        return $name;
    }

    /**
     * Обработка запроса от системы оплаты
     * Метод должен завершать поток путем вызова bff::shutdown();
     * @param string $system ключ обрабываемой системы оплаты
     */
    public function process($system)
    {
        if ($system != static::KEY) return;

        $MNT_ID             = $this->getValue('MNT_ID');
        $MNT_TRANSACTION_ID = $this->getValue('MNT_TRANSACTION_ID');
        $MNT_OPERATION_ID   = $this->getValue('MNT_OPERATION_ID');
        $MNT_AMOUNT         = $this->getValue('MNT_AMOUNT');
        $MNT_CURRENCY_CODE  = $this->getValue('MNT_CURRENCY_CODE');
        $MNT_TEST_MODE      = $this->getValue('MNT_TEST_MODE');
        $MNT_SIGNATURE      = $this->getValue('MNT_SIGNATURE');

        $return = 'FAIL#1';
        if ($MNT_ID && $MNT_TRANSACTION_ID) {
            $return = 'FAIL#2';
            $secret = $this->config('secret');
            if (empty($secret)) {
                \bff::log('PayAnyWay: Не указана настройка Secret', Logger::ERROR, 'bills.log');
            }
            $signature = md5($MNT_ID . $MNT_TRANSACTION_ID . $MNT_OPERATION_ID . $MNT_AMOUNT . $MNT_CURRENCY_CODE . $MNT_TEST_MODE . $secret);
            if ($MNT_SIGNATURE == $signature) {
                $return = 'FAIL#3';
                $mResult = $this->bills()->processBill($MNT_TRANSACTION_ID, $MNT_AMOUNT, self::ID);
                if ($mResult === true) {
                    $return = 'SUCCESS';
                }
            }
        }

        if (($return == 'SUCCESS' || $return = 'FAIL#3') && $this->config('fz54', false)) {
            do {
                $billData = Bills::model()->billData($MNT_TRANSACTION_ID);
                if (empty($billData['id'])) {
                    \bff::log('PayAnyWay: process: bill not found #' . $MNT_TRANSACTION_ID, Logger::ERROR, 'bills.log');
                    break;
                }

                $userData = Users::model()->userData($billData['user_id'], array('email'));
                if (empty($userData['email'])) {
                    \bff::log('PayAnyWay: process: user not found #' . $billData['user_id'], Logger::ERROR, 'bills.log');
                    break;
                }

                $svcData = Svc::model()->svcData($billData['svc_id']);
                $name = $this->getServiceName($billData['svc_id'], $svcData);
                $name = trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($name)));

                $item = [
                    'name' => $name,
                    'price' => $billData['amount'],
                    'quantity' => 1,
                    'vatTag' => $this->config('fz54vatType', '1105'),
                    'pm' => $this->config('fz54pm', 'full_payment'),
                    'po' => $this->config('fz54po', 'service'),
                ];
                $inventory = [$item];

                $return = '<?xml version="1.0" encoding="UTF-8" ?>' . PHP_EOL;
                $return .= '<MNT_RESPONSE>' . PHP_EOL;
                $return .= '<MNT_ID>' . $MNT_ID . '</MNT_ID>' . PHP_EOL;
                $return .= '<MNT_TRANSACTION_ID>' . $MNT_TRANSACTION_ID . '</MNT_TRANSACTION_ID>' . PHP_EOL;
                $result = '200';
                $return .= '<MNT_RESULT_CODE>' . $result . '</MNT_RESULT_CODE>' . PHP_EOL;
                $signature = md5($result . $MNT_ID . $MNT_TRANSACTION_ID . $secret);
                $return .= '<MNT_SIGNATURE>' . $signature . '</MNT_SIGNATURE>' . PHP_EOL;
                $return .= '<MNT_ATTRIBUTES>' . PHP_EOL;
                $return .= '<ATTRIBUTE>' . PHP_EOL;
                $return .= '<KEY>INVENTORY</KEY>' . PHP_EOL;
                $return .= '<VALUE>' . json_encode($inventory) . '</VALUE>' . PHP_EOL;
                $return .= '</ATTRIBUTE>' . PHP_EOL;
                $return .= '<ATTRIBUTE>' . PHP_EOL;
                $return .= '<KEY>CUSTOMER</KEY>' . PHP_EOL;
                $return .= '<VALUE>' . $userData['email'] . '</VALUE>' . PHP_EOL;
                $return .= '</ATTRIBUTE>' . PHP_EOL;
                $return .= '</MNT_ATTRIBUTES>' . PHP_EOL;
                $return .= '</MNT_RESPONSE>' . PHP_EOL;
                header('Content-type: application/xml');
            } while (false);
        }

        echo $return;
        bff::shutdown();
    }

    protected function getValue($name)
    {
        $value = false;
        if (isset($_POST[$name])) $value = $_POST[$name];
        if (isset($_GET[$name])) $value = $_GET[$name];
	    return $value;
    }
}